using System;
using System.Text.Json.Serialization;
namespace org.accordproject.finance.bond {
   using org.accordproject.organization;
   using org.accordproject.time;
   using org.accordproject.money;
   using concerto;
   enum CouponType {
      FIXED,
      FLOATING,
   }

   class PaymentFrequency : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.finance.bond.PaymentFrequency";
      public int periodMultiplier { get; set; }
      public Duration period { get; set; }
   }
   class Bond : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.finance.bond.Bond";
      public string[] instrumentId { get; set; }
      public string description { get; set; }
      public CurrencyCode currency { get; set; }
      public string[] exchangeId { get; set; }
      public string clearanceSystem { get; set; }
      public string definition { get; set; }
      public string seniority { get; set; }
      public CouponType couponType { get; set; }
      public float couponRate { get; set; }
      public DateTime maturity { get; set; }
      public float parValue { get; set; }
      public float faceAmount { get; set; }
      public PaymentFrequency paymentFrequency { get; set; }
      public string dayCountFraction { get; set; }
      public Organization issuer { get; set; }
   }
   class BondAsset : Asset {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.finance.bond.BondAsset";
      public string ISINCode { get; set; }
      public Bond bond { get; set; }
   }
}
